/* Triple-DES Example
 * ------------------
 *     unsigned char key1[8];
 *     unsigned char key2[8];
 *     unsigned char key3[8];
 *     unsigned char plaintext[8];
 *     unsigned char ciphertext[8];
 *     unsigned char recoverd[8];
 *     tripledes_ctx context;
 *
 *     * If you would like to use two 64bit keys, fill 'key1' and'key2'
 *       then setup the encryption context: *
 *     tripledes_set2keys(context, key1, key2);
 *
 *     * To use three 64bit keys with Triple-DES use: *
 *     tripledes_set3keys(context, key1, key2, key3);
 *
 *     * Encrypting plaintext with Triple-DES *
 *     tripledes_ecb_encrypt(context, plaintext, ciphertext);
 *
 *     * Decrypting ciphertext to recover the plaintext with Triple-DES *
 *     tripledes_ecb_decrypt(context, ciphertext, recoverd);
 *
 */

/*
unsigned char weak_keys_chksum[20] = {
  0xD0, 0xCF, 0x07, 0x38, 0x93, 0x70, 0x8A, 0x83, 0x7D, 0xD7,
  0x8A, 0x36, 0x65, 0x29, 0x6C, 0x1F, 0x7C, 0x3F, 0xD3, 0x41
};
*/


#include <stdio.h>
#include "polarssl/des.h"


int main()
{
  //unsigned char key1[8] = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'};
  //unsigned char key2[8] = {'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p'};
  //unsigned char key3[8] = {'q', 'r', 's', 't', 'u', 'v', 'w', 'x'};
  unsigned char key3[24] = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h',
			    'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p',
			    'q', 'r', 's', 't', 'u', 'v', 'w', 'x'};

  unsigned char plaintext[8] = {'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a'};
  unsigned char ciphertext[8];
  unsigned char recoverd[8];
  //tripledes_ctx context;
  des3_context ctx;

  

  int i = 0;
  printf("Key 1:");
  for (i = 0; i<8; i++)
  {
    printf("%c", key3[i]);
  }
  printf("\n");
  
  printf("Key 2:");
  for (i = 0; i<8; i++)
  {
    printf("%c", key3[i]);
  }
  printf("\n");

  printf("Key 3:");
  for (i = 0; i<8; i++)
  {
    printf("%c", key3[i]);
  }
  printf("\n");


  printf("Plaintext:");
  for (i = 0; i<8; i++)
  {
    printf("%X", plaintext[i]);
  }
  printf("\n");
  printf("size of plain text:%d\n", sizeof(plaintext));
  //tripledes_set3keys(context, key1, key2, key3);
  //tripledes_ecb_encrypt(context, plaintext, ciphertext);
  des3_set3key_enc(&ctx, key3);
  des3_crypt_ecb(&ctx, plaintext, ciphertext);

  printf("Ciphertext:");
  for (i = 0; i<8; i++)
  {
    printf("%X", ciphertext[i]);
  }
  printf("\n");
  printf("size of ciphertext:%d\n", sizeof(ciphertext));
  des3_set3key_dec(&ctx, key3);
  des3_crypt_ecb(&ctx, ciphertext, recoverd);

  printf("Recoverd:");
  for (i = 0; i<8; i++)
  {
    printf("%X", recoverd[i]);
  }
  printf("\n");

  return 0;
}
